# PlutoUI.jl

![](https://media.giphy.com/media/l3vRfDn9ca5PVkHv2/giphy.gif)


```@meta
CurrentModule = PlutoUI
```

# Essentials

## Number inputs
```@docs
Slider
NumberField
Scrubbable
# RangeSlider
```

## String inputs
```@docs
TextField
PasswordField
ColorStringPicker
DateField
TimeField
```

## Selecting
```@docs
Radio
Select
MultiSelect
MultiCheckBox
```

## Clicky click
```@docs
CheckBox
Button
CounterButton
LabelButton
```




# Display helpers
```@docs
TableOfContents
br
Resource
LocalResource
```

## Terminal addiction
```@docs
Print
Dump
with_terminal
```

## Advanced IO control
```@docs
Show
WithIOContext
# as_html
# as_mime
# as_png
# as_svg
# as_text
```


# Special inputs


```@docs
FilePicker
DownloadButton
# Clock
```

# High-level components
```@docs
combine
confirm
```